---@class vec2
---@field public x number
---@field public y number
local _a = {}

---@return vec2
function _a:clone() end

---@return boolean
function _a:valid() end

---@return number
function _a:len() end

---@return number
function _a:lenSqr() end

---@return vec2
function _a:norm() end

---@param vecType vec2
---@param delta number
---@overload fun(vecType:vec3, delta:number):vec2
---@return vec2
function _a:lerp(vecType, delta) end

---@param vecType vec2
---@param dist number
---@overload fun(vecType:vec3, dist:number):vec2
---@return vec2
function _a:extend(vecType, dist) end

---@param vecType vec2
---@param dist number
---@overload fun(vecType:vec3, dist:number):vec2
---@return vec2
function _a:shorten(vecType, dist) end

---@param angle number
---@return vec2
function _a:rotate(angle) end

---@param vecType vec2
---@overload fun(vecType:vec3):number
---@return number
function _a:dist(vecType) end

---@param vecType vec2
---@overload fun(vecType:vec3):number
---@return number
function _a:distSqr(vecType) end

---@param vecType vec2
---@overload fun(vecType:vec3):number
---@return number
function _a:dot(vecType) end

---@param vecType vec2
---@overload fun(vecType:vec3):number
---@return number
function _a:angle(vecType) end

---@return vec2
function _a:perp1() end

---@return vec2
function _a:perp2() end

---@param vecType vec2
---@param range number
---@overload fun(vecType:vec3, dist:number):boolean
---@return boolean
function _a:isInRange(vecType, range) end

---@return boolean
function _a:isOnScreen() end

---@class vec3
---@field public x number
---@field public y number
---@field public z number
local _a = {}

---@return vec3
function _a:clone() end

---@return boolean
function _a:valid() end

---@return number
function _a:len() end

---@return number
function _a:lenSqr() end

---@return number
function _a:lenSqr() end

---@param vecType vec3
---@param delta number
---@overload fun(vecType:vec2, delta:number):vec3
---@return vec3
function _a:lerp(vecType, delta) end

---@param vecType vec3
---@param dist number
---@overload fun(vecType:vec2, dist:number):vec3
---@return vec3
function _a:extend(vecType, dist) end

---@param vecType vec3
---@param dist number
---@overload fun(vecType:vec2, dist:number):vec3
---@return vec3
function _a:shorten(vecType, dist) end

---@param angle number
---@return vec3
function _a:rotate(angle) end

---@param vecType vec2
---@overload fun(vecType:vec3):number
---@return number
function _a:dist(vecType) end

---@param vecType vec2
---@overload fun(vecType:vec3):number
---@return number
function _a:distSqr(vecType) end

---@param vecType vec2
---@overload fun(vecType:vec3):number
---@return number
function _a:dot(vecType) end

---@param vecType vec2
---@overload fun(vecType:vec3):number
---@return number
function _a:angle(vecType) end

---@return vec3
function _a:perp1() end

---@return vec3
function _a:perp2() end

---@param vecType vec3
---@param range number
---@overload fun(vecType:vec2, range:number):boolean
---@return boolean
function _a:isInRange(vecType, range) end

---@return boolean
function _a:isOnScreen() end

---@param delta number
---@return vec3
function _a:randomize(delta) end

---@param min number
---@param max number
---@overload fun(max:number):vec3
---@return vec3
function _a:clamp(min, max) end

---@return boolean
function _a:isZero() end

---@param tolerance number
---@overload fun():boolean
---@return boolean
function _a:isUnderEnemyTurret(tolerance) end

---@param tolerance number
---@overload fun():boolean
---@return boolean
function _a:isUnderAllyTurret(tolerance) end

---@return vec2
function _a:to2D() end

---@return vec2
function _a:toScreen() end

---@return vec3
function _a:to3DWorld() end

---@return vec3
function _a:to3DPlayer() end

---@return boolean
function _a:isWall() end

---@return boolean
function _a:isGrass() end

---@return boolean
function _a:isInJungle() end

---@class path
---@field active boolean
---@field index number
---@field startPos vec3
---@field endPos vec3
---@field serverPos vec3
---@field point vec3[]
---@field point2D vec2[]
---@field count number
---@field dashSpeed number
---@field isDashing boolean
---@field serverVelocity vec3
---@field serverVelocity2D vec2
local _a = {}

---@class rune
---@field ID number
---@field name string
---@field displayName string
local _a = {}

---@class runeManager
---@field rune rune
local _a = {}

---@class avatar
---@field hasRunes boolean
---@field runes runeManager[]
local _a = {}

---@class spellData
---@field displayName string
---@field castRangeGrowInterval boolean
---@field cantCancelWhileWindingUp boolean
---@field cantcancelWhileChanneling boolean
---@field channelIsInterruptedByAttacking boolean
---@field projectTargetToCastRange boolean
---@field castRangeUseBoundingBoxes boolean
---@field canMoveWhileChanneling boolean
---@field isToggleSpell boolean
---@field castConeAngle number
---@field castConeDistance number
---@field missileUpdateDistanceInterval number
---@field castType number
---@field missileSpeed number
---@field lineWidth number
local _a = {}

---@class spell
---@field name string
---@field static spellData
---@field counter number
---@field levelIndex number
---@field casterID number
---@field startPos vec3
---@field endPos vec3
---@field startPos2D vec2
---@field endPos2D vec2
---@field castPosition vec3
---@field hasTarget boolean
---@field owner gameobject
---@field ownerID number
---@field target gameobject
---@field windUpTime number
---@field animationTime number
---@field clientWindUpTime number
---@field animationWindUpTime number
---@field isBasicAttack boolean
---@field isSpecialAttack boolean
---@field slot number
local _a = {}

---@class spellCastData
---@field casterID number
---@field targetID number
---@field pos vec3
---@field endPos vec3
---@field startPos vec3
---@field castPos vec3
local _a = {}

---@class spellSlot
---@field name string
---@field level number
---@field cooldownEndTime number
---@field ammo number
---@field stacks number
---@field rechargeEndTime number
---@field toggleState number
---@field slot number
---@field state number
---@field ammoCurrentCooldown number
---@field castData spellCastData
---@field static spellData
---@field cooldown number
local _a = {}

---@class item
---@field stacks number
---@field ammo number
---@field id number
---@field maxStacks number
---@field name number
local _a = {}

---@class heroInventory
local _a = {}

---@param index number
---@return item
function _a:getSlot(index) end

---@class gameobject
---@field valid boolean
---@field name string
---@field charName string
---@field recallName string
---@field pos vec3
---@field dir vec3
---@field pos2D vec2
---@field dir2D vec2
---@field velocity vec3
---@field barPos vec2
---@field path path[]
---@field activeSpell spell
---@field type number
---@field index number
---@field team number
---@field x number
---@field y number
---@field z number
---@field isOnScreen boolean
---@field isDead boolean
---@field isVisible boolean
---@field isRecalling boolean
---@field isTargetable boolean
---@field parEnabled boolean
---@field sarEnabled boolean
---@field isCampAlive boolean
---@field isUntargetableToEnemies boolean
---@field isUntargetableToAllies boolean
---@field isZombie boolean
---@field isStructure boolean
---@field isAlly boolean
---@field isEnemy boolean
---@field isNeutral boolean
---@field isMonster boolean
---@field isBaseAI boolean
---@field isMinion boolean
---@field isHero boolean
---@field isTurret boolean
---@field isBuilding boolean
---@field isAttackableUnit boolean
---@field isParticleEmitter boolean
---@field isMissile boolean
---@field isInvulnerable boolean
---@field isMagicImmune boolean
---@field isPhysicalImmune boolean
---@field willReviveOnDeath boolean
---@field isImmovable boolean
---@field isStealthed boolean
---@field isTaunted boolean
---@field isFeared boolean
---@field isFleeing boolean
---@field isSupressed boolean
---@field isAsleep boolean
---@field isGhosted boolean
---@field isCharmed boolean
---@field isSlowed boolean
---@field isDisarmed boolean
---@field isRooted boolean
---@field isSilenced boolean
---@field isStunned boolean
---@field isBaseTurret boolean
---@field isLaneMinion boolean
---@field isSuperMinion boolean
---@field isSiegeMinion boolean
---@field isPet boolean
---@field isWard boolean
---@field isTrap boolean
---@field isPlant boolean
---@field isLargeMonster boolean
---@field isEpicMonster boolean
---@field isDragon boolean
---@field isMoving boolean
---@field isDashing boolean
---@field isMe boolean
---@field isMelee boolean
---@field isRanged boolean
---@field isHardCCd boolean
---@field isHardMoveCCd boolean
---@field deathTime number
---@field boundingRadius number
---@field networkID number
---@field health number
---@field maxHealth number
---@field allShield number
---@field physicalShield number
---@field magicalShield number
---@field champSpecificHealth number
---@field isTargetableToTeamFlags number
---@field mana number
---@field maxMana number
---@field baseAttackDamage number
---@field armor number
---@field spellBlock number
---@field attackSpeedMod number
---@field flatPhysicalDamageMod number
---@field percentPhysicalDamageMod number
---@field physicalDamagePercentageMod number
---@field flatMagicDamageMod number
---@field percentMagicDamageMod number
---@field magicalDamagePercentageMod number
---@field healthRegenRate number
---@field bonusArmor number
---@field bonusSpellBlock number
---@field moveSpeed number
---@field scaleSkinCoef number
---@field gold number
---@field goldTotal number
---@field minimumGold number
---@field evolvePoints number
---@field evolveFlag number
---@field inputLocks number
---@field skillUpLevelDeltaReplicate number
---@field manaCost number
---@field manaCost0 number
---@field manaCost1 number
---@field manaCost2 number
---@field manaCost3 number
---@field baseAbilityDamage number
---@field dodge number
---@field crit number
---@field totalAttackDamage number
---@field totalAbilityPower number
---@field totalBaseAttackDamage number
---@field totalBonusAttackDamage number
---@field totalBaseAbilityPower number
---@field totalBonusAbilityPower number
---@field parRegenRate number
---@field attackRange number
---@field flatMagicReduction number
---@field percentMagicReduction number
---@field flatCastRangeMod number
---@field percentCooldownMod number
---@field passiveCooldownEndTime number
---@field passiveCooldownTotalTime number
---@field flatArmorPenetration number
---@field percentArmorPenetration number
---@field flatMagicPenetration number
---@field percentMagicPenetration number
---@field percentLifeStealMod number
---@field percentSpellVampMod number
---@field percentBonusArmorPenetration number
---@field percentBonusMagicPenetration number
---@field percentCritBonusArmorPenetration number
---@field percentCritTotalArmorPenetration number
---@field physicalLethality number
---@field baseHealthRegenRate number
---@field primaryARBaseRegenRateRep number
---@field secondaryARRegenRateRep number
---@field secondaryARBaseRegenRateRep number
---@field percentCooldownCapMod number
---@field percentEXPBonus number
---@field flatBaseAttackDamageMod number
---@field percentBaseAttackDamageMod number
---@field baseAttackDamageSansPercentScale number
---@field exp number
---@field par number
---@field maxPar number
---@field sar number
---@field maxSar number
---@field levelRef number
---@field campID number
---@field statusFlags number
---@field teleportType number
---@field teleportName string
---@field actionState number
---@field actionState2 number
---@field dampenerState number
---@field percentDamageToBarracksMinionMod number
---@field flatDamageReductionFromBarracksMinionMod number
---@field percentBonusAttackDamageMod number
---@field percentMultiplicativeAttackSpeedMod number
---@field critDamageMultiplier number
---@field tenacity number
---@field petId number
---@field combatType number
---@field upgradePoints number
---@field lastTargetNetworkID number
---@field respawnTimer number
---@field serverPos vec3
---@field pathPos vec3
---@field currentPathIndex number
---@field pathEndPos vec3
---@field pathStartPos vec3
---@field nextPathPos vec3
---@field buffManager buffManager
---@field buff buff[]
---@field attacksInfo spell[]
---@field heroInventory heroInventory
---@field owner gameobject
---@field cloneOf gameobject
---@field avatar avatar
---@field startPos vec3
---@field endPos vec3
---@field startPos2D vec3
---@field endPos2D vec3
---@field spell spell
local _a = {}

--if isBaseAI
---@param slot number
---@return spellSlot
function _a:basicAttack(slot) end

--if isHero
---@param slot number
---@return spellSlot
function _a:spellSlot(slot) end

---@param slot number
---@return number
function _a:spellState(slot) end

---@return number
function _a:timerExpiry() end

---@return number
function _a:attackCastDelay() end

---@param slot number
---@return number
function _a:attackCastDelayEx(slot) end

---@return number
function _a:attackDelay() end

---@param runeID number
---@return number
function _a:findRune(runeID) end

---@return number
function _a:hardCCdTime() end

---@return number
function _a:hardMoveCCdTime() end

---@return boolean
function _a:canDie() end

---@return boolean
function _a:canAttack() end

---@return boolean
function _a:canCrit() end

---@return boolean
function _a:canCast() end

---@return boolean
function _a:canMove() end

---@return boolean
function _a:canAttack() end

---@return number
function _a:totalHealth() end

---@return number
function _a:totalMaxHealth() end

---@return number
function _a:totalShield() end

---@param target gameobject
---@return number
function _a:getAutoAttackRange(target) end

---@param target gameobject
---@param range number
---@return boolean
function _a:isInAutoAttackRange(target, range) end

---@param target gameobject
---@return boolean
function _a:isFacing(target) end

---@param name string
---@return buff
function _a:findBuffByName(name) end

---@param buffType number
---@return buff
function _a:findBuffOfType(buffType) end

---@param itemID number
---@return item
function _a:findItem(itemID) end

---@overload fun(vec:vec2):number
---@overload fun(vec:vec3):number
---@return number
function _a:dist() end

--if isMe
---@param itemID number
---@return boolean
function _a:buyItem(itemID) end

---@param slot number
---@return boolean
function _a:levelSpell(slot) end

---@param mode string
---@param slot number
---@return boolean
function _a:levelSpell(mode, slot) end

---@class buff
---@field type number
---@field name string
---@field startTime number
---@field endTime number
---@field counter number
---@field valid boolean
---@field source gameobject
---@field stacks number
---@field stacks2 number
local _a = {}

---@class buffManager
---@field count number
local _a = {}

---@param index number
---@return buff
function _a:get(index) end

---@class zenbot
local _a = {}

---@return boolean
function _a.isPrivilegedUser() end

---@class cb
---@field public draw number
---@field public draw2 number
---@field public pre_tick number
---@field public tick number
---@field public issueorder number
---@field public delete_object number
---@field public create_object number
---@field public load number
---@field public path number
---@field public destroy number
---@field public castspell number
---@field public wndproc number
---@field public keydown number
---@field public keyup number
---@field public cancelattack number
---@field public teleport number
---@field public spell number
---@field public evade number
local _a = {}

---@param eventId number
---@param func function
---@return nil
function _a.add(eventId, func) end

---@param func function
---@return nil
function _a.remove(func) end

---@class chat
---@field public isOpen boolean
local _a = {}

---@param message string
---@return nil
function _a.send(message) end

---@param message string
---@return nil
function _a.print(message) end

---@class consoleType
---@field public title string
---@field public pos vec2
---@field public size vec2
---@field public height number
---@field public shouldClose boolean
local _a = {}

---@param message string
---@return nil
function _a:print(message) end

---@class console
---@field public default consoleType
local _a = {}

---@param message string
---@return nil
function _a.print(message) end

---@param title string
---@overload fun()
---@return consoleType
function _a.new(title) end

---@class hash
local _a = {}

---@param name string
---@return number
function _a.FNV1a(name)
end

---@param name string
---@return string
function _a.translate(name)
end

---@class minimap
---@field public x number
---@field public y number
---@field public width number
---@field public height number
---@field public bounds vec2
local _a = {}

---@param vecType vec2
---@overload fun(vecType:vec3)
---@return vec2 @screen position on minimap
function _a.world_to_map(vecType)
end

---@param vecType vec2
---@overload fun(vecType:vec3)
---@return boolean @true if screen position is over minimap
function _a.on_map(vecType)
end

---@param x number
---@param y number
---@return boolean @true if screen position is over minimap
function _a.on_map_xy(x, y) end

---@param vecType number
---@param radius number
---@param line_width number
---@param color number
---@return nil
function _a.draw_circle(vecType, radius, line_width, color) end

---@class navmesh
local _a = {}

---@param vecType vec2
---@overload fun(vecType:vec3)
---@return number
function _a.flagsAt(vecType) end

---@param vecType vec2
---@overload fun(vecType:vec3)
---@return number
function _a.heightAt(vecType) end

---@param vecType vec2
---@overload fun(vecType:vec3)
---@return boolean
function _a.isWall(vecType) end

---@param vecType vec2
---@overload fun(vecType:vec3)
---@return boolean
function _a.isGrass(vecType) end

---@param vecType vec2
---@overload fun(vecType:vec3)
---@return boolean
function _a.isStructure(vecType) end

---@param vecType vec2
---@overload fun(vecType:vec3)
---@return vec3
function _a.nearestPassableCenter(vecType) end

---@class game
---@field public mousePos vec3
---@field public mousePos2D vec2
---@field public cursorPos vec2
---@field public time number
---@field public selectedTarget gameobject
---@field public hoveredTarget gameobject
---@field public mapID number
---@field public isMatchmade boolean
---@field public mode string
---@field isWindowFocused boolean
local _a = {}

---@class graphics
---@field width number
---@field height number
---@field res vec2
---@field anchor_n number
---@field anchor table
local _a = {}

---@param a number
---@param r number
---@param g number
---@param b number
---@return number
function _a.argb(a, r, g, b) end

---@param vecType vec2
---@overload fun(vecType:vec2)
---@return vec2
function _a.world_to_screen(vecType) end

---@param x number
---@param y number
---@param z number
---@return vec2
function _a.world_to_screen_xyz(x, y, z) end

---@param text string
---@param size number
---@param x number
---@param y number
---@param z number
---@return nil
function _a.draw_text_2D(text, size, x, y, z) end

---@param x1 number
---@param y1 number
---@param x2 number
---@param y2 number
---@param width number
---@param color number
---@return nil
function _a.draw_line_2D(x1, y1, x2, y2, width, color) end

---@param vecType1 vec2
---@param vecType2 vec2
---@param width number
---@param color number
---@overload fun(vecType1:vec3, vecType2:vec2, width:number, color:number):nil
---@overload fun(vecType1:vec2, vecType2:vec3, width:number, color:number):nil
---@overload fun(vecType1:vec3, vecType2:vec3, width:number, color:number):nil
---@return nil
function _a.draw_line(vecType1, vecType2, width, color) end

---@param v1 vec2
---@param radius number
---@param width number
---@param color number
---@overload fun(v1:vec3, radius:number, width:number, color:number):nil
---@return nil
function _a.draw_circle(v1, radius, width, color) end

---@param x number
---@param y number
---@param z number
---@param radius number
---@param width number
---@param color number
---@return nil
function _a.draw_circle_xyz(x, y, z, radius, width, color) end

---@param x number
---@param y number
---@param radius number
---@param width number
---@param color number
---@return nil
function _a.draw_circle_2D(x, y, radius, width, color) end

---@param str string
---@param size number
---@param n number
---@return nil
function _a.text_area(str, size, n) end

---@param points vec2[]
---@param width number
---@param color number
---@param n number
---@param closed boolean
---@overload fun(points:vec3[], width:number, color:number, n:number, closed:boolean)
---@return nil
function _a.draw_line_strip(points, width, color, n, closed) end

---@param points vec2[]
---@param width number
---@param color number
---@param n number
---@param closed boolean
---@overload fun(points:vec3[], width:number, color:number, n:number, closed:boolean)
---@return nil
function _a.draw_line_strip_2D(points, width, color, n, closed) end

---@param object gameobject
---@param damage number
---@param color number
---@param end_color number
---@return nil
function _a.draw_damage(object, damage, color, end_color) end

---@param object gameobject
---@param healing number
---@param color number
---@param end_color number
---@return nil
function _a.draw_healing(object, healing, color, end_color) end

---@param object gameobject
---@param shielding number
---@param color number
---@param end_color number
---@return nil
function _a.draw_shielding(object, shielding, color, end_color) end

---@class objManager
---@field player gameobject
---@field iturrets function
---@field iheroes function
---@field ibouldings function
---@field iminions function
---@field nexus gameobject[]
local _a = {}

---@param f function
---@return nil
function _a.loop(f) end

---@class keyboard
local _a = {}

---@param key number
---@return boolean
function _a.isKeydown(key) end

---@class network
---@field latency number
local _a = {}

---@param host string
---@param request string
---@param port number
---@return string
function _a.request(host, request, port) end

---@class module
local _a = {}

---@param id string
---@return any
function _a.internal(id) end

---@param id string
---@return any
function _a.lib(id) end

---@param id string
---@param name string
---@return any
function _a.load(id, name) end

---@param id string
---@return any
function _a.seek(id) end

---@class Global
---@field public zenbot zenbot
---@field public cb cb
---@field public chat chat
---@field public console console
---@field public hash hash
---@field public minimap minimap
---@field public navmesh navmesh
---@field public game game
---@field public graphics graphics
---@field public objManager objManager
---@field public keyboard keyboard
---@field public network network
---@field public module module
---@field public player gameobject
---@field public mousePos vec3
---@field public mousePos2D vec2
---@field public TEAM_ALLY number
---@field public TEAM_ENEMY number
---@field public TEAM_NEUTRAL number
---@field public TYPE_TROY number
---@field public TYPE_HERO number
---@field public TYPE_MINION number
---@field public TYPE_MISSILE number
---@field public TYPE_TURRET number
---@field public TYPE_INHIB number
---@field public TYPE_NEXUS number
---@field public TYPE_SPAWN number
---@field public TYPE_SHOP number
---@field public TYPE_CAMP number
local _a = {}

---@overload fun(x:number):vec2
---@overload fun(x:number, y:number):vec2
---@overload fun(vecType:vec2):vec2
---@overload fun(vecType:vec3):vec2
---@return vec2
function _a.vec2() end

---@overload fun(x:number):vec3
---@overload fun(x:number, y:number):vec3
---@overload fun(x:number, y:number, z:number):vec3
---@overload fun(vecType:vec2):vec3
---@overload fun(vecType:vec3):vec3
---@return vec3
function _a.vec3() end

---@class menu

---@param id string
---@param display string
---@return menu
function _a.menu(id, display) end

---@type Global
_G = _G

_G.SpellSlot =
{
  Q = 0,
  W = 1,
  E = 2,
  R = 3,
  Summoner1 = 4,
  Summoner2 = 5,
  Item1 = 6,
  Item2 = 7,
  Item3 = 8,
  Item4 = 9,
  Item5 = 10,
  Item6 = 11,
  Trinket = 12,
  Recall = 13,
  SpecialAttack = 46,
  P = 63,
  BasicAttack = 65,
};
_G.OrbwalkingMode =
{
  None = 0,
  Combo = 2,
  Mixed = 4,
  LastHit = 8,
  LaneClear = 16,
  Harass = 32,
  Flee = 64
};
_G.SpellState =
{
  Ready = 0,
  NotAvailable = 2,
  NotLearned = 4,
  Supressed = 8,
  Disabled = 16,
  Cooldown = 32,
  NoMana = 64,
};
_G.ToggleState =
{
  None = 0,
  NotToggled = 1,
  Toggled = 2,
};
_G.TeleportStatus =
{
  Unknown = 0,
  Idle = 1,
  Start = 2,
  Abort = 3,
  Finish = 4,
};
_G.TeleportType =
{
  Unknown = 0,
  Recall = 1,
  Teleport = 2,
  Gate = 3,
  Shen = 4,
};
_G.Buff =
{
  Internal = 0,
  Aura = 1,
  CombatEnchancer = 2,
  CombatDehancer = 3,
  SpellShield = 4,
  Stun = 5,
  Invisibility = 6,
  Silence = 7,
  Taunt = 8,
  Polymorph = 9,
  Slow = 10,
  Snare = 11,
  Damage = 12,
  Heal = 13,
  Haste = 14,
  SpellImmunity = 15,
  PhysicalImmunity = 16,
  Invulnerability = 17,
  AttackSpeedSlow = 18,
  NearSight = 19,
  Currency = 20,
  Fear = 21,
  Charm = 22,
  Poison = 23,
  Suppression = 24,
  Blind = 25,
  Counter = 26,
  Shred = 27,
  Flee = 28,
  Knockup = 29,
  Knockback = 30,
  Disarm = 31,
  Grounded = 32,
  Drowsy = 33,
  Asleep = 34,
}
local _type = type
type = setmetatable({
  char = -0x1,
  int = -0x2,
  float = -0x4,
  bool = -0x8,
  double = -0x10,
  ptr = -0x20,
  vec2 = -0x40,
  vec3 = -0x80,
  vec4 = -0x100,
  array = -0x200,
  short = -0x400,
  byte = -0x800,
  matrix = -0x1000,
  uint = -0x2000,
  ushort = -0x4000,
  null = -0x8000,
  cfn = {
    stdcall = 0,
    cdecl = 1,
    thiscall = 2
  },
}, { __call = function(_, ...) return _type(...) end })

function _G.class(name)
end